// Copyright 2016 Orus.io. All rights reserved.

package mocks

import (
	"testing"

	"xbus.io/xbus/storage"
	"xbus.io/xbus/testutils"
	storagetest "xbus.io/xbus/testutils/storage"
)

func factory(tb testing.TB) (storage.EnvelopeStorage, func()) {
	tb.Helper()
	return NewEnvelopeStorage(testutils.GetTestLogger(tb)), func() {}
}

func TestEnvelopeStorage(t *testing.T) {
	storagetest.EnvelopeStorageTests(t, factory, storagetest.EnvelopeStorageTestsOptions{
		SupportUnordered:     true,
		SupportParallelStore: true,
	})
}

func BenchmarkEnvelopeStorage(b *testing.B) {
	storagetest.EnvelopeStorageBench(b, factory)
}
